window.Gleam.initSearch([{"doc":"glemo","title":"glemo","content":"# glemo\n\n[![Package Version](https://img.shields.io/hexpm/v/glemo)](https://hex.pm/packages/glemo)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/glemo/)\n\nSimple function memoization over Erlang ETS / JavaScript Map for Gleam\n\n```sh\ngleam add glemo\n```\n```gleam\nimport glemo\n\npub fn main() {\n  // init caches on application startup\n  glemo.init([&quot;my_cache&quot;])\n\n  // try get from cache\n  // on first attempt item not exists in cache\n  // fallback function will be called\n  // result of fallback function will be placed to cache, function argument is used as key\n  1\n  |&gt; glemo.memo(&quot;my_cache&quot;, fn(x) { x + 1 }) // 2\n\n  // now value returned from cache, fallback function ignored\n  1\n  |&gt; glemo.memo(&quot;my_cache&quot;, fn(x) { x + 1 }) // 2\n\n  // invalidate cache item by specific key\n  glemo.invalidate_specific(1, &quot;my_cache&quot;)\n\n  // invalidate all cache\n  glemo.invalidate_all(&quot;my_cache&quot;)\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/glemo&gt;.\n\n## Development\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\ngleam shell # Run an Erlang shell\n```\n","url":"index.html"},{"doc":"glemo","title":"init","content":"pub fn init(caches: List(String)) -&gt; Nil\n\nSynonyms:\nglemo.init\nglemo init","url":"glemo.html#init"},{"doc":"glemo","title":"invalidate_all","content":"pub fn invalidate_all(cache_name: String) -&gt; Nil\n\nSynonyms:\nglemo.invalidate_all\nglemo invalidate_all","url":"glemo.html#invalidate_all"},{"doc":"glemo","title":"invalidate_specific","content":"pub fn invalidate_specific(arg: a, cache_name: String) -&gt; Nil\n\nSynonyms:\nglemo.invalidate_specific\nglemo invalidate_specific","url":"glemo.html#invalidate_specific"},{"doc":"glemo","title":"memo","content":"pub fn memo(arg: a, cache_name: String, fun: fn(a) -&gt; b) -&gt; b\n\nSynonyms:\nglemo.memo\nglemo memo","url":"glemo.html#memo"},{"doc":"glemo","title":"glemo","content":"","url":"glemo.html"}]);